/**
 *Authentication service.
 *
 *@author  			Qian Chen
 *@coplyright 		Copyright (c) 2015, zuber.im
 *@lincence
 */

(function(){
	'user strict';

	/**
	 * @ngInject
	 */
	 function AuthenticationProvider() {
	 	this.$get = function($rootScope, $http, $state, $ionicScrollDelegate, LoginService, Restangular, ProfileService, localStorageService, Token, Signature, jPushService, ResponseService, TEST_MODE) {
	 		/**
	 		 * @ngdoc method
	 		 * @name authentication#loginSuccess
	 		 * @params {string} response
	 		 * @description login success callback to get user auth from backend
	 		 */

	 		if(TEST_MODE){
	 				var test_uid = "78";

	 				Token.set( test_uid, "adsfadsf", "111111" );

	 				$rootScope.loginState = true;

	 				var _userApi = 'commons/'+ test_uid +'/user'

	 				Signature.set(_userApi, {}, 'get');

	 				//get User Profile
	 				Restangular.one('/commons/'+ test_uid +'/user').get().then(function(data) {

	 					$rootScope.ifNewAccount = (data.result.room_id == "") ? true : false;
	 					$rootScope.ifBindPhone  = (data.result.phone != "") ? true : false;

	 					if ( $rootScope.ifNewAccount ) {
	 						$rootScope.me = {
	 							user:""
	 						}
	 						$rootScope.me.user = data.result;
	 						//go to step1
	 						$state.go('app.register_step1')
	 						$rootScope.beginRegister = true;

	 					} else if( !$rootScope.ifBindPhone ) {

	                        $state.go('app.register_step3');
	                        $rootScope.beginRegister = true;

                    	} else {
	 						//get user info
	 						ProfileService.getUser().then(function(data) {
			 					$rootScope.me        = data.result;
								localStorageService.set( "user", angular.toJson( data.result ) );
			 				})
	 					}
	 				})

	 				if (!TEST_MODE) {
	 					jPushService.bind();
	 				}
	 		}

	 		var loginSuccess = function(response,callback) {
	 			var _params;

	 			if (!response.access_token) {
	 				//source weixin
	 				_params = {
	 					source: 'weixin',
	 					code:   response.code
	 				}

	 			} else {
	 				//source weibo
	 				_params = {
	 					source:       'weibo',
	 					userid: 	  response.userid,
	 					access_token: response.access_token
	 				}
	 			}
	 			/***************Set Headers****************/
	 			Signature.set('users/oauth', _params, 'post')
				/******************************************/
	 			Restangular
	 			.all('users/oauth')
	 			.post(_params)
	 			.then(function(data){
	 				ResponseService.handle(data, function() {
	 					//console.log(data.result.uid + " " + data.result.token + " " + data.result.secret )
		 				LoginService.onLoginSuccess(data);
	 				})

	 			})
	 		}
	 		/**
	 		 * @ngdoc method
	 		 * @name authentication#loginfail
	 		 * @oarams {string} failReason
	 		 * @ndescription login fail callback
	 		 */
	 		var onFail = function(failReason) {
	 		 	throw new Error(failReason);
	 		}
	 		 /**
	 		  * @ngdoc method
	 		  * @name authentication#onLogout
	 		  * @description trigger when logout
	 		  * @params {string} source
	 		  *
	 		  */
	 		var onLogout = function(source) {
	 			 //clear user auth
	 			 Token.clear();

         $rootScope.hasNewMessage = false;
	 			 //reset uid
	 			 //currentUserId = null;
	 		}

	 		//weibo login
	 		var weiboApp = function() {
	 			this.ssoLogin = function() {
	 				YCWeibo.ssoLogin(loginSuccess, onFail);
	 			}

	 			this.logout = function() {
	 				YCWeibo.logout(onLogout, onFail);
	 			}
	 		}

	 		//weixin login
	 		var weixinApp = function() {
	 			this.authLogin = function() {
	 				var scope = "snsapi_userinfo";
	 				Wechat.auth(scope, loginSuccess, onFail);
	 			}
	 		}

	 		var weibo = new weiboApp;
	 		var weixin = new weixinApp;

	 		return {
	 			signin: function(source) {

	 				localStorageService.set('source', source);

	 				switch(source) {
	 					case "weibo":
	 						weibo.ssoLogin();
	 						break;
	 					case "weixin":
	 						weixin.authLogin();
	 						break;
	 				}
	 			},
	 			signout: function(source) {
	 				//set loginState
	 				$rootScope.loginState = false;
	 				$ionicScrollDelegate.scrollTop();

	 				var _api = "users"+ Token.getApiUid() + "/logout";
	 				/**********Set Headers********/
	 				Signature.set(_api, {}, 'post')
	 				/*****************************/
	 				Restangular
	 				.all(_api)
	 				.post({})
	 				.then(function(data){
	 					if (source == 'weibo') {
	 						weibo.logout();
	 					} else {
	 						onLogout();
	 					}

	 				})

	 			},
	 			isAuthenticated: function() {
	 				return !!Token.getUid();
	 			},
	 			getCurrentUserId: function() {
	 				return localStorageService.get('uid');
	 			}
	 		}
	 	}
	 }

	 angular
	 .module('app.core')
	 .provider('Authentication',AuthenticationProvider);
})();
