/**
 *Jpush service.
 *
 *@author  			Qian Chen 
 *@coplyright 		Copyright (c) 2015, zuber.im
 *@lincence
 */
(function(){
	'use strict';

	/**
	 * @ngInject
	 */
	function jPushProvider($http, Restangular, localStorageService, Token, Signature) {
		var _ridStorageKey = 'registration_id',
			_cachedRid 	   = '';

		return {
			bind: function() {
				var _uid    = Token.getApiUid(),
					_api    = "pushs" + _uid;
			 		
				window.plugins.jPushPlugin.getRegistrationID(function(data) {

					if (data != ''){
						_cachedRid = data;
						localStorageService.set(_ridStorageKey, _cachedRid);

						var _params = {
							registration_id: localStorageService.get(_ridStorageKey)
						}

						Signature.set(_api, _params, 'post');

						Restangular
						.all(_api)
						.post(_params)
						.then(function(data){
							console.log('bind success');
						})
					}
				})
			}
		}
	}

	angular
	.module('app.core')
	.factory('jPushService',jPushProvider)
})()