/**
 *Signature service.
 *
 *@author  			Qian Chen 
 *@coplyright 		Copyright (c) 2015, zuber.im
 *@lincence
 */
(function(){
	'user strict';

	/**
	 * @ngInject
	 */
	function Signature($http, Token, API_VERSION) {
			/*
			 * @generate timeStamp 
			 */
			var timeStamp = function() {
				return Math.round(new Date().getTime()/1000);
			}
			/*
			 * @ngdoc method 
			 * @name signature#set
			 * @
			 */
			var set = function(api, params, method) {
				var _secret    = Token.getSecret();
				var _token     = Token.getToken();
				var _timeStamp = timeStamp();

				_secret        = (_secret) ? _secret : "";
				_token         = (_token) ? _token : md5(timeStamp());

				var _source    = "request_url="    + API_VERSION + api 	    +"&"+
								 "content=" 	   + angular.toJson(params)	+"&"+
								 "request_method=" + method 				+"&"+
					             "timestamp=" 	   + _timeStamp 			+"&"+
					             "secret="		   + _secret

				var _signature = md5( _source );
				
				console.log(_source);

				console.log(_signature);

				var _auth = 'timestamp='	+ _timeStamp  +";"+
				            'oauth2='		+ _token	   +";"+
				            'signature='	+ _signature

				$http.defaults.headers.common.Authorization = _auth;
			}

			return {
				set:set
			}
	}

	angular
	.module('app.core')
	.factory('Signature',Signature);
})()