/**
 * Cache service.
 *
 * @author  			Qian Chen 
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function() {
	"user strict";
	/**
     * @ngdoc service
     * @name CacheService
     * @module app.core
     * @requires $http, Restangular, Token, Signature
     * @description
     * Service to get the search data.
     *
     * @ngInject
     */
    function CacheService(localStorageService) {
    	return {
    		/**
             * @ngdoc method
             * @name CacheService:modify
             * @params {string} cachedkey, modifyKey, modifyValue
             * @description
             * modify cached data.
             *
             * 
             */
            modify: function(cachedkey, modifyKey, modifyValue) {
                //get cached data
                var _temp = JSON.parse( localStorageService.get(cachedkey) );
                //modify with new data
                _temp[ modifyKey ] = modifyValue;
                //save back
                localStorageService.set(cachedkey, angular.toJson(_temp) );

            }
    	}

    }




	angular
	.module('app.core')
	.factory('CacheService', CacheService)
})()