/**
 * Cache service.
 *
 * @author  			Qian Chen 
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function() {
	"user strict";
	/**
     * @ngdoc service
     * @name CacheService
     * @module app.core
     * @requires $http, Restangular, Token, Signature
     * @description
     * Service to get the search data.
     *
     * @ngInject
     */
    function DeviceService($http, Restangular, Token, Signature) {
        
    	return {
    		/**
             * @ngdoc method
             * @name CacheService:modify
             * @params {string} cachedkey, modifyKey, modifyValue
             * @description
             * modify cached data.
             *
             * 
             */
            getInfor: function(deviceInfo, appVersion, networkType) {

                var _uid   = Token.getApiUid();
                var _api   = "commons" + _uid + '/terminal';

                var params = {
                    device_platform     : deviceInfo.platform,
                    device_model        : deviceInfo.model,    
                    device_version      : deviceInfo.version,
                    device_manufacturer : deviceInfo.manufacturer,
                    app_version         : appVersion,
                    network             : networkType
                }

                console.log(angular.toJson(params));

                Signature.set(_api, {}, 'get');

                return Restangular
                       .one(_api)
                       .get(params) 
            }
    	}

    }




	angular
	.module('app.core')
	.factory('DeviceService', DeviceService)
})()