/**
 *Authentication interceptor.
 *
 *@author  			Qian Chen 
 *@coplyright 		Copyright (c) 2015, zuber.im
 *@lincence
 */
(function() {
	'use strict';

	/**
     * @description
     * The http interceptor that listens for errors.
     *
     * @param $q
     * 
     * @returns {{responseError: responseError}}
     * @constructor
     * @ngInject
     */
    function ErrorInterceptor($q, $cordovaDialogs) {
    	return {
    		responseError: function(rejection) {
    			console.log(JSON.stringify(rejection));
    			return $q.reject(rejection);
    		}
    	}
    }

    angular
    .module('app.core')
    .factory('ErrorInterceptor',ErrorInterceptor)
    .config(function ($httpProvider) {
    	// we have to add the interceptor to the queue as a string because the interceptor depends upon service instances that are not available in the config block.
        $httpProvider.interceptors.push('ErrorInterceptor');
    })
})()