/**
 * Mate service.
 *
 * @author  			Qian Chen 
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function() {
	'user strict';

	/**
     * @ngdoc service
     * @name MateService
     * @module app.core
     * @requires $http, Restangular, Token, Signature
     * @description
     * Service to get and modify the mate states.
     *
     * @ngInject
     */
	function MateService($http, Restangular, Token, Signature) {
		return {
			/**
             * @ngdoc method
             * @name MateService:set
             * @description
             * set user mate states.
             *
             * @returns {promise} A promise which is resolved in set result.
             */
			set: function(params) {
				var _uid = Token.getApiUid();
				var _api = 'rooms' + _uid + "/mate";
				Signature.set(_api, params, 'put');

				return Restangular
					   .one(_api)
				       .customPUT(params)
			}
		}
	}

	angular
	.module('app.core')
	.factory('MateService', MateService)
})()