/**
 * Modal service.
 *
 * @author  			Qian Chen
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function() {
	'user strict';

	/**
     * @ngdoc service
     * @name SocialService
     * @module app.core
     * @requires $http, Restangular, Token, Signature
     * @description
     * Service to get the visit, browse data.
     *
     * @ngInject
     */
    function LoginService($http, $state, $rootScope, $ionicHistory, $ionicPlatform, HintService, Restangular, Token, Signature, localStorageService, jPushService, ProfileService, TEST_MODE) {


    	return {
    		onLoginSuccess:function(data) {
                console.log(data.result.uid)

                Token.set( data.result.uid, data.result.token, data.result.secret );

                if (!TEST_MODE) { jPushService.bind(); }

                $rootScope.loginState = true;
                $rootScope.throwOnce  = true;

                var _userApi = 'commons/'+ data.result.uid +'/user'

                Signature.set(_userApi, {}, 'get');

                Restangular.one(_userApi).get().then(function(data) {
                    $rootScope.me           = {
                        user:""
                    }
                    console.log(_userApi + ":" + angular.toJson(data));

                    $rootScope.me.user      = data.result;
                    $rootScope.ifNewAccount = (data.result.room_id == "") ? true : false;

                    console.log("phone: " + data.result.phone);

                    $rootScope.ifBindPhone  = (data.result.phone != "") ? true : false;

                    console.log("ifBind: " + $rootScope.ifBindPhone);



                    if ( $rootScope.ifNewAccount ) {

                        //go to step1
                        $state.go('app.register_step1');
                        $rootScope.beginRegister = true;

                    } else if( !$rootScope.ifBindPhone ) {

                        ProfileService.getUser().then(function(data) {

                          console.log(angular.toJson(data.result));

                          $rootScope.me        = data.result;
                          localStorageService.set( "user", angular.toJson( data.result ) );
                        })

                        console.log('go to step3');
                        $state.go('app.register_step3');
                        $rootScope.beginRegister = true;

                    } else {
                        ProfileService.getUser().then(function(data) {

                          console.log(angular.toJson(data.result));

                          $rootScope.me        = data.result;
                          localStorageService.set( "user", angular.toJson( data.result ) );
                        })

                        $state.go('app.dashboard');

                        $rootScope.phoneSource = false;
                    }
                })
            }
    	}

    }


	angular
	.module('app.core')
	.factory('LoginService', LoginService)
})()
