/**
 * Message service.
 *
 * @author  			Qian Chen 
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function() {
	"user strict";
	/**
     * @ngdoc service
     * @name Messageservice
     * @module app.core
     * @requires $http, Restangular, Token, Signature
     * @description
     * Service to get the search data.
     *
     * @ngInject
     */
    function MessageService($rootScope, $http, Restangular, Token, Signature) {
    	return {
    		/**
             * @ngdoc method
             * @name CommentService:list
             * @params {object} params,category
             * @description
             * get comment list.
             *
             * @returns {promise} A promise which is resolved in comment data.
             */
            notification: function() {
                var _uid = Token.getApiUid();
                var _api = "messages" + _uid + "/notification"

                Signature.set(_api, {}, 'get');

            	return Restangular
            		   .one(_api)
            	       .get(); 
            },
            reset: function() {
                $rootScope.hasNewMessage = false;

                var _uid = Token.getApiUid();
                var _api = "messages" + _uid + "/notification"

                Signature.set(_api, {}, 'put');

                return Restangular
                       .one(_api)
                       .customPUT(); 
            }
    	}

    }




	angular
	.module('app.core')
	.factory('MessageService', MessageService)
})()