/**
 * Modal service.
 *
 * @author  			Qian Chen
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function() {
	'user strict';

	/**
     * @ngdoc service
     * @name SocialService
     * @module app.core
     * @requires $http, Restangular, Token, Signature
     * @description
     * Service to get the visit, browse data.
     *
     * @ngInject
     */
    function ModalService($state,$ionicModal) {
    	return {
    		createModal: function($scope, modalTemplate) {
                var ifFocus = ( $state.current.name =='app.messages' ) ? false : true;

    			return $ionicModal.fromTemplateUrl(modalTemplate, {
    				scope                : $scope,
    				animation            : 'slide-in-up',
            backdropClickToClose : false,
    				focusFirstInput      : ifFocus
    			})
    		}
    	}

    }


	angular
	.module('app.core')
	.factory('ModalService', ModalService)
})()
