/**
 * Modal service.
 *
 * @author  			Qian Chen 
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function() {
	'user strict';

	/**
     * @ngdoc service
     * @name SocialService
     * @module app.core
     * @requires $http, Restangular, Token, Signature
     * @description
     * Service to get the visit, browse data.
     *
     * @ngInject
     */
    function RegisterService($http, $rootScope, localStorageService, Restangular, Token, Signature, ResponseService, LoginService) {
    	return {
    		phoneRegist: function(phone, captcha, password, ifreset) {
                var _lockedPassword = md5(password);
                var _api            = (ifreset) ? "users/password" : "users";
                var _param          = {
                    phone    : phone,
                    captcha  : captcha,
                    password : _lockedPassword
                }

                Signature.set(_api, _param, 'post')
                
                 return Restangular
                        .all(_api)
                        .post(_param)
                        .then(function(data) {
                             ResponseService.handle(data, function() {
                                $rootScope.phoneSource = true;
                                LoginService.onLoginSuccess(data);
                             })
                        })
            },

            phoneLogin: function(phone, password) {
                var _lockedPassword = md5(password);
                var _api            = 'users/login';
                var _param          = {
                    phone    : phone,
                    password : _lockedPassword
                }

                Signature.set(_api, _param, 'post');

                return  Restangular
                        .all(_api)
                        .post(_param)
                        .then(function(data) {
                             ResponseService.handle(data, function() {
                                $rootScope.phoneSource = true;
                                LoginService.onLoginSuccess(data);
                             })
                        });
            },

            getCaptcha: function(phone, ifnew) {
                var _uid   = Token.getApiUid();
                var _api   = 'users' +_uid+ '/captcha';
                var _param = {
                    phone : phone,
                    ifnew : ifnew
                }

                Signature.set(_api, _param, 'post')

                return Restangular
                       .all(_api)
                       .post(_param)
            },

            phoneBind: function(phone, captcha) {
                var _uid   = Token.getApiUid();
                console.log(_uid);
                var _api   = 'users' + _uid + '/bind';
                var _param = {
                    type    : ( localStorageService.get('source') == 'weibo' ) ? 'weibo_phone' : 'weixin_phone',
                    phone   : phone,
                    captcha : captcha
                }

                Signature.set(_api, _param, 'post');

                return Restangular
                       .all(_api)
                       .post(_param)
            }
    	}

    }


	angular
	.module('app.core')
	.factory('RegisterService', RegisterService)
})()