/**
 *Search service.
 *
 *@author  			Qian Chen 
 *@coplyright 		Copyright (c) 2015, zuber.im
 *@lincence
 */
(function() {
    "user strict";
	/**
     * @ngdoc service
     * @name SearchService
     * @module app.core
     * @requires $http, Restangular, Token, Signature
     * @description
     * Service to get the search data.
     *
     * @ngInject
     */
    function SearchService(Restangular, Token, Signature, TEST_MODE) {
    	
    	
    	return {
    		/**
             * @ngdoc method
             * @name SearchService:list
             * @params {object} params
             * @description
             * get room list.
             *
             * @returns {promise} A promise which is resolved in room data.
             */
    		list: function(ifMulti, params) {
                var _uid = Token.getApiUid();
    			var _api = ( ifMulti )? 'rooms' +_uid +"/find" : 'rooms' +_uid +"/search";
	   			Signature.set(_api, {}, 'get');

                if (TEST_MODE) {
                    console.log("api: "+ _api + "&params: "+ params)
                }

    			return Restangular
    				   .one(_api)
    				   .get(params); 
    		}
    	}
    }

	angular
	.module('app.core')
	.factory('SearchService', SearchService)
})()