/**
 * Share service.
 *
 * @author  			Qian Chen 
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function() {
    "user strict";
	/**
     * @ngdoc service
     * @name ShareService
     * @module app.core
     * @requires $http, Restangular, Token, Signature
     * @description
     * Service to get the search data.
     *
     * @ngInject
     */
    function ShareService(Restangular, HintService, Token, Signature, TEST_MODE) {
    	var onSuccess = function() {
            HintService.loadingHint('share');
        }

        var onFail = function(failReason) {
            throw new Error(failReason);
        }
    	
    	return {
    		/**
             * @ngdoc method
             * @name SearchService:list
             * @params {object} params
             * @description
             * get room list.
             *
             * @returns {promise} A promise which is resolved in room data.
             */
    		weiboShare: function(title, description, imageUrl, url, text) {
                var args         = {};
                args.url         = url;
                args.title       = title;
                args.description = description;
                args.imageUrl    = imageUrl;
                args.defaultText = text;

                YCWeibo.shareToWeibo(onSuccess, onFail, args);
    		},


            weixinShare: function(title, description, imageUrl, url, text, place) {
                Wechat.share({
                    message: {
                        title:         title,
                        description:   description,
                        thumb:         imageUrl,
                        messageExt:    text,
                        messageAction: "<action>dotalist</action>",
                        media: {
                            type:       Wechat.Type.LINK,
                            webpageUrl: url
                        }
                    },
                    scene: ( place == 'timeline') ? Wechat.Scene.TIMELINE : Wechat.Scene.SESSION
                
                }, onSuccess, onFail);
            }
    	}
    }

	angular
	.module('app.core')
	.factory('ShareService', ShareService)
})()