/**
 *User service.
 *
 *@author  			Qian Chen 
 *@coplyright 		Copyright (c) 2015, zuber.im
 *@lincence
 */
(function() {
	'use strict';

	/**
     * @ngdoc service
     * @name UserService
     * @module app.core
     * @requires $http, Restangular, Token, Signature
     * @description
     * Service to get the specific user data.
     *
     * @ngInject
     */
    function UserService($http, Restangular, Token, Signature) {
    	return {
    		/**
             * @ngdoc method
             * @name UserService:getUserById
             * @description
             * get user information.
             *
             * @returns {promise} A promise which is resolved in specific user data.
             */
    		getUserById: function(params) {
                var _uid = Token.getApiUid();
    			var _api = 'users' + _uid;
				Signature.set(_api, {}, 'get');

				return Restangular
					   .one(_api)
					   .get(params);
    		}
    	}
    }

	angular
	.module('app.core')
	.factory('UserService', UserService)
})()