/**
 * Browse controller.
 *
 * @author  			Qian Chen 
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function() {
	'user strict';

	/**
     * @ngdoc controller
     * @name SocialCtrl
     * @module app.follow
     * @description
     * Controller for the social page.
     *
     * @ngInject
     */
    function BrowseCtrl($rootScope, $scope, SocialService, ResponseService, TEST_MODE) {
    	var zub = this;
        
        zub.processing = true;
        
        SocialService.browse().then(function(data){
            ResponseService.handle(data, function() {
                zub.processing = false;
                zub.browseList = data.result.items;
            });         
        });

        zub.doRefresh = function() {
            SocialService.browse().then(function(data){

                ResponseService.handle(data, function() {
                    zub.browseList = data.result.items;
                    $scope.$broadcast('scroll.refreshComplete');   
                });

            });
        }
    }

	angular
	.module('app.browse')
	.controller('BrowseCtrl',BrowseCtrl)
})()