/**
 * Dashboard controller.
 *
 * @author  			Qian Chen
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function () {
    'use strict';

    /**
     * @ngdoc controller
     * @name DashboardCtrl
     * @module app.dashboard
     * @requires $state
     * @requires localStorageService, Authentication
     * @description
     * Controller for the dashboard page.
     *
     * @ngInject
     */
    function DashboardCtrl($scope, $state, $rootScope, $ionicPlatform, $ionicHistory, ResponseService, HintService, localStorageService, ProfileService, Authentication, TEST_MODE) {
        var zub          = this,
            _logged      = $rootScope.loginState,
            _sourcekey   = 'source',
            _sourceValue = localStorageService.get(_sourcekey);

        $scope.$on('$stateChangeStart', function() {

            $ionicHistory.nextViewOptions({
                disableBack: false
            });
        })

        if (!TEST_MODE) {
            Wechat.isInstalled(function (installed) {
                zub.wechat = installed;
            }, function (reason) {
                throw new Error(reason);
            });
        }


        document.addEventListener('deviceready', function() {

            if ( _logged ) {
                zub.me = JSON.parse( localStorageService.get('user') );
            }

            zub.login = function(source) {
                _sourceValue = source;
                localStorageService.set(_sourcekey, _sourceValue);

                Authentication.signin(source)
            }
        })


        zub.logout = function() {
            HintService.comfirmHint('退出登录', '您确定要退出该账号吗？', function() {
                Authentication.signout(_sourceValue);
            })
        }
    }

    angular
        .module('app.dashboard')
        .controller('DashboardCtrl', DashboardCtrl);
})();
