/**
 * Follow controller.
 *
 * @author  			Qian Chen 
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function() {
	'user strict';

	/**
     * @ngdoc controller
     * @name SocialCtrl
     * @module app.follow
     * @description
     * Controller for the social page.
     *
     * @ngInject
     */
    function FollowCtrl($rootScope, $scope, $ionicModal, ResponseService, FollowService, HintService, TEST_MODE) {
    	var zub = this;
        
        zub.processing = true;

        FollowService.list().then(function(data){
            ResponseService.handle(data, function() {
                zub.processing = false;
                zub.followList = data.result.items;
            });
        });

        zub.doRefresh = function() {
            FollowService.list().then(function(data){
                ResponseService.handle(data, function() {
                    zub.followList = data.result.items;
                    $scope.$broadcast('scroll.refreshComplete');
                })
            });
        }

        zub.unfollow = function($index, uid) {
            HintService.comfirmHint('取消关注', '您确定要取消关注该用户吗？', function(){
                FollowService.unfollow({ object_uid: uid }).then(function(data){
                    ResponseService.handle(data, function() {
                        zub.followList.splice($index, 1);
                    })
                })
            })
        }

    }

	angular
	.module('app.follow')
	.controller('FollowCtrl',FollowCtrl)
})()