/**
 * Dashboard controller.
 *
 * @author  			Qian Chen
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function () {
    'use strict';

    /**
     * @ngdoc controller
     * @name DashboardCtrl
     * @module app.dashboard
     * @requires $state
     * @requires localStorageService, Authentication
     * @description
     * Controller for the dashboard page.
     *
     * @ngInject
     */
    function PhoneCtrl($scope, $state, $rootScope, $ionicHistory, RegisterService, ResponseService, HintService, TEST_MODE) {
        var zub = this;

        zub.phone   = "";
        zub.captcha = "";

        function validate() {
            switch(true) {
                case zub.phone == undefined || "":
                     HintService.alertHint("请填写手机号");
                     return false;
                     break;
                case !zub.phone.match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/):
                     HintService.alertHint("您的手机号不合法");
                     return false;
                     break;
                case zub.captcha == undefined || "":
                     HintService.alertHint('请填写验证码');
                     return false;
                     break;
                default:
                    return true;
                    break;
            }
        }

        zub.sendCaptcha = function() {
            if ( zub.phone == undefined || "" ) {
                HintService.alertHint("请填写手机号")
            } else if (!zub.phone.match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/)) {
                HintService.alertHint("您的手机号不合法");
            } else {
                var ifnew = (zub.reset) ? 1 : 0;
                zub.captchaDelay = true;
                zub.seconds      = 60;

                RegisterService.getCaptcha(zub.phone, ifnew).then(function(data) {

                    ResponseService.handle(data, function() {


                        zub.reset        = false;

                        var secondCount = setInterval(function() {
                            if( zub.seconds == 0 ) {
                                zub.captchaDelay = false;
                                $scope.$apply();
                                clearInterval(secondCount);
                            }

                            zub.seconds--;
                            $scope.$apply();


                        }, 1000);
                    }, function() {
                        zub.captchaDelay = false;
                    })

                });
            }

        }

        zub.completeBind = function() {
            if ( validate() ) {
                zub.processing = true;
                RegisterService.phoneBind(zub.phone, zub.captcha).then(function(data) {
                    ResponseService.handle(data, function() {

                        console.log(angular.toJson(data));

                        $ionicHistory.nextViewOptions({
                            disableBack: true
                        });

                        $rootScope.loginState    = true;
                        $rootScope.ifNewAccount  = false;
                        $rootScope.beginRegister = false;
                        zub.processing = false;

                        zub.captcha = "";

                        $state.go('app.dashboard');


                    })

                    zub.processing = false;
                })
            }
        }
    }

    angular
        .module('app.phone')
        .controller('PhoneCtrl', PhoneCtrl);
})();
