/**
 *User route.
 *
 *@author  			Qian Chen 
 *@coplyright 		Copyright (c) 2015, zuber.im
 *@lincence
 */
(function() {
	'user strict';

	/**
     * @ngdoc object
     * @name userRoute
     * @module app.user
     * @requires $stateProvider
     * @description
     * Router for the user detail page.
     *
     * @ngInject
     */
    function userRoute($stateProvider) {
        $stateProvider
            .state('app.user', {
                url:   '/roomsearch/user/:UserID',
                views: {
                    'roomsearch': {
                        templateUrl : 'js/routes/user/user.html',
                        controller  : 'UserCtrl as zub'
                    }
                }
            })

            .state('app.followDetail', {
                url:   '/follow/user/:UserID', 
                views: {
                    'dashboard': {
                        templateUrl : 'js/routes/user/user.html',
                        controller  : 'UserCtrl as zub'
                    }
                }
            })

            .state('app.visitDetail', {
                url:   '/visit/user/:UserID',
                views: {
                    'dashboard': {
                        templateUrl : 'js/routes/user/user.html',
                        controller  : 'UserCtrl as zub'
                    }
                }
            })

            .state('app.browseDetail', {
                url:   '/browse/user/:UserID',
                views: {
                    'dashboard': {
                        templateUrl : 'js/routes/user/user.html',
                        controller  : 'UserCtrl as zub'
                    }
                }
            })

            .state('app.dashDetail', {
                url:   '/dashboard/user/:UserID',
                views: {
                    'dashboard': {
                        templateUrl : 'js/routes/user/user.html',
                        controller  : 'UserCtrl as zub'
                    }
                }
            })

            .state('app.messageDetail', {
                url:   '/messages/user/:UserID',
                views: {
                    'messages': {
                        templateUrl : 'js/routes/user/user.html',
                        controller  : 'UserCtrl as zub'
                    }
                }
            });
    }

    angular
    .module('app.user')
    .config(userRoute);
})()