/**
 * Visit controller.
 *
 * @author  			Qian Chen 
 * @coplyright 		Copyright (c) 2015, zuber.im
 * @lincence
 */
(function() {
	'user strict';

	/**
     * @ngdoc controller
     * @name SocialCtrl
     * @module app.follow
     * @description
     * Controller for the social page.
     *
     * @ngInject
     */
    function VisitCtrl($rootScope, $scope, ResponseService, SocialService, TEST_MODE) {
    	var zub = this;

        zub.processing = true;
        
        SocialService.visit().then(function(data){
            ResponseService.handle(data, function() {
                zub.processing = false;
                zub.visitList  = data.result.items;                
            });
            
        });

        zub.doRefresh = function() {
            SocialService.visit().then(function(data){
                ResponseService.handle(data, function() {
                    zub.visitList = data.result.items;
                    $scope.$broadcast('scroll.refreshComplete');            
                });
                    
            });
        }
    }

	angular
	.module('app.visit')
	.controller('VisitCtrl',VisitCtrl)
})()